#!/usr/bin/python

# ZADATAK 1

# Napraviti program koji pronalazi ukupne brojeve pojavljivanja svih karaktera iz ascii
# tabele u okviru svih fajlova koji se nalaze unutar zadatog direktorijuma. 

# Npr. ako korisnik zada putanju C://Program Files/ (ili /home/), potrebno je da program prodje
# kroz sve datoteke rekurzivno. Svaki karakter se broji zasebno, malo i veliko slovo 'A'
# su razliciti karakteri. 

# Brojeve pojavljivanja u toku rada programa pohranjivati u recniku (mapi), a potom na 
# kraju zapisati u datoteci koja se naziva npr. C_Program_Files_frekvencije.txt (odnosno home_frekvencije.txt)

import sys
import os
import my_utils

# arg init and checks
if len(sys.argv) == 1:
	path = "/"
elif len(sys.argv) == 2:
	path = sys.argv[1]
else:
	print("lol n00b")
	exit()
print("Requested path: " + str(path))

## Opens the file 'file_name', reads it whole
## and counts the number of times each char occurs
## Data is saved into map named 'log_data'
def count_characters(log_data, file_name):
	file_to_count = open(file_name)
	#DEBUG print("filetoread: " + file_name)
	while True:
		runner = file_to_count.read(1)
		if runner == '':
			break
		if runner in log_data:
			log_data[runner] += 1
		else:
			log_data[runner] = 1
	file_to_count.close()
	# finally, we return the update log data
	return log_data		

## Writes the log into 'log_path' file
## Data it writes is contained in log_data
def write_log(log_path, log_data):
	log_path += "/log.txt"
	log = open(log_path, "w")
	for key in log_data.keys():
		log.write(str(key) + ": " + str(log_data[key]) + "\n")
	log.close()
	print("Log writen at: " + str(log_path))

## Calls count_characters(...) function for each .txt file it finds
##	and saves the data is generated with function write_log(...) 
## Searches recursively the file sistem for .txt files starting from 'path'
def count_ascii_chars(path):
	log_data = {}
	if not os.path.exists(path):
		print("Wrong path!\nn00b")
		exit()
	# gives us the location of the script that you're currently reading
	log_path = my_utils.get_script_location()
	for currDir, dirs, files in os.walk(path):
		for f in files:
			if currDir[-1] != "/":
				file_name = currDir + "/" + f
			else:
				file_name = currDir + f
			# let's count the characters in file
			if not file_name.endswith(".txt"):
				continue
			
			log_data = count_characters(log_data, file_name)

	write_log(log_path, log_data)

 
count_ascii_chars(path)

