#!/usr/bin/python

# ZADATAK 2
#
# Napraviti program koji za sve postojece ekstenzije datoteka nalazi brojeve datoteka, linija koda u njima i prosecan broj linija koda po datoteci. 
# Pritom, uzimati u obzir samo datoteke koje se nalaze u okviru zadatog direktorijum. 
# Npr. ako korisnik zada putanju C://Program Files/ (ili /home/), potrebno je uzeti
# u obzir samo datoteke koje se nalaze u okviru ovog direktorijuma (rekurzivno). Izlaz ispisati datoteci C_Program_Files_linije.txt (odnosno home_linije.txt) u formi:
# 
# ekstenzija	broj_datoteka	broj_linija		prosecan_broj_linija
# txt			1003			204542			203
# doc			203				450035			2216
# ...

import os
import sys

if len(sys.argv) != 2:
	print("Homie you gotta gimme path!")
	exit()

path = sys.argv[1]
log_data = {}
allowed_extensions = {"txt", "py", "c", "java", "cpp", "js", "html", "xml", "tex", "json", "yml", "md", "perl", "css", "php", "go", "vala", "dart", "cs", "sql", "coffee"}

## Reading files starting from 'path', saving data into 'log_data'
for curr_dir, dirs, files in os.walk(path):
	# we iterate through all files
	for f in files:
		# reading the file extension	
		extension = f.split(".")[-1]

		if not extension in allowed_extensions:
			continue
		
		# counting the file 
		if extension in log_data:
			log_data[extension][0] += 1
		else:
			log_data[extension] = [0, 0]	
	
		# reading file 
		try:
			if not curr_dir.endswith("/"):
				reader = open(curr_dir + "/" + f, "r")			
				print("Opened file: " + curr_dir + "/" + f)
			else:
				reader = open(curr_dir + f, "r")			
				print("Opened file: " + curr_dir + f)
		except IOError:
			print("Couldn't read file: " + str(f))
			exit()
		
		# counting the lines
		try:
			log_data[extension][1] += len(reader.readlines())
			reader.close()
		except UnicodeDecodeError:
			print("Failed at reading file: " + curr_dir + "/" + f)
			print("Ignoring file...")		
		
## Writing everything into log file
log_file = open("02_log_data.txt", "w")
log_file.write("Data from: " + path + "\n\n")
log_file.write("ekstenzija".ljust(20) + "broj_datoteka".ljust(20) + "broj_linija".ljust(20) + "prosecan_br_linija".ljust(20) + "\n")
for key in log_data.keys():
	average = float(log_data[key][1] / log_data[key][0])
	average = round(average, 2)
	log_file.write(key.ljust(20) + str(log_data[key][0]).ljust(20) + str(log_data[key][1]).ljust(20) + str(average) + "\n")
log_file.close()
print("Log saved in file: 02_log_data.txt")
