package inputform;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.scene.text.TextBuilder;
import javafx.stage.Stage;

public class SignInForm extends Application {

	@Override
	public void start(Stage stage) throws Exception {
		GridPane grid = new GridPane();
		grid.setAlignment(Pos.CENTER);
		grid.setVgap(10);
		grid.setHgap(10);
		grid.setPadding(new Insets(10, 10, 10, 10));

		Text title = new Text("Welcome");
		title.setFont(new Font(20));
		grid.add(title, 0, 0, 2, 1);

		Text userLab = new Text("User name:");
		grid.add(userLab, 0, 1);
		TextField userTxt = new TextField();
		grid.add(userTxt, 1, 1);

		Text passLab = new Text("Password:");
		grid.add(passLab, 0, 2);
		TextField passTxt = new TextField();
		grid.add(passTxt, 1, 2);

		Text noteLab=new Text("");
		noteLab.setFill(Color.RED);
		grid.add(noteLab, 0, 4,2,1);
		
		Button btn = new Button("Sign in.");
		HBox hbBtn=new HBox();
		hbBtn.setAlignment(Pos.CENTER_RIGHT);
		hbBtn.getChildren().add(btn);
		grid.add(hbBtn, 1, 3);
		
		btn.setOnAction(new EventHandler<ActionEvent>() {

			@Override
			public void handle(ActionEvent arg0) {
				noteLab.setText("Succesfull login.");
			}
		});

		Scene scene = new Scene(grid, 300, 300);
		stage.setScene(scene);
		stage.show();
	}

	public static void main(String[] args) {
		Application.launch(args);
	}

}
