package tableviewgeneric;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.geometry.Insets;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.layout.VBox;
import javafx.scene.text.Font;
import javafx.stage.Stage;

public class TableGUI extends Application {

	@Override
	public void start(Stage stage) {
		Scene scene = new Scene(new Group());
		stage.setTitle("Table View Sample");
		stage.setWidth(450);
		stage.setHeight(500);

		final Label label = new Label("Address Book");
		label.setFont(new Font("Arial", 20));

		TableView<Person> table = new TableView<Person>();
		
		ObservableList<Person> data = FXCollections.observableArrayList(
				new Person("Petar", "Petrovic", "ppetrovic@example.com"),
				new Person("Ana", "Joksic", "ajoksic@example.com"),
				new Person("Aleksandar", "Kartelj",
						"aleksandar.kartelj@gmail.com"));

		//pravimo kolone i asociramo ih sa poljima u klasi Person
		TableColumn<Person, String> firstNameCol = new TableColumn<Person, String>("First Name");
		firstNameCol.setCellValueFactory(new PropertyValueFactory<Person, String>("firstName"));
		TableColumn<Person, String> lastNameCol = new TableColumn<Person, String>("Last Name");
		lastNameCol.setCellValueFactory(new PropertyValueFactory<Person, String>("lastName"));
		TableColumn<Person, String> emailCol = new TableColumn<Person, String>("Email");
		emailCol.setCellValueFactory(new PropertyValueFactory<Person, String>("email"));

		table.getColumns().add(firstNameCol);
		table.getColumns().add(lastNameCol);
		table.getColumns().add(emailCol);
		
		table.setItems(data);
		
		firstNameCol.setMinWidth(100);
		lastNameCol.setMinWidth(100);
		emailCol.setMinWidth(200);

		final VBox vbox = new VBox();
		vbox.setSpacing(5);
		vbox.setPadding(new Insets(10, 0, 0, 10));
		vbox.getChildren().addAll(label, table);

		((Group) scene.getRoot()).getChildren().addAll(vbox);

		stage.setScene(scene);
		stage.show();
	}

	public static void main(String[] args) {
		launch(args);
	}
}