package cells;
import java.awt.Canvas;
import java.awt.Graphics;
import java.util.Random;

public class CellularAutomatCanvas extends Canvas
{
    private Random rg = new Random();

    private Cell[][] cells = new Cell[40][40];
    private Organism organism;

    public CellularAutomatCanvas(int n)
    {
        setSize(400, 400);

        // alociramo n vrsti
        for (int i = 0; i < n; i++) {
            cells[i] = new Cell[40];
            for (int j = 0; j < n; j++)
                cells[i][j] = new Cell(this,i,j);
        }
        organism = new Organism(cells, this);
        for(int i=0; i<n; i++)
            for(int j=0; j<n; j++)
                cells[i][j].start();

    }

    public int getRandom(int a, int b)
    {
        return rg.nextInt(b - a + 1) + a;
    }

    @Override
    public void paint(Graphics g)
    {
        for (int i = 0; i < cells.length; i++)
            for (int j = 0; j < cells[i].length; j++)
                cells[i][j].drawSelf(g);

    }
}
