package withoutSync;

/**
 * Created by skazzi on 10/28/15.
 */
public class Shop extends Thread
{
    private int stock;
    private final int limit = 1000;
    private Warehouse warehouse;

    public Shop(Warehouse warehouse) {
        // shops are empty and they need to restock from the warehouse
        this.stock = 0;
        this.warehouse = warehouse;
    }

    public int getNumberOfChocolates() {
        return stock;
    }

    public void setNumberOfChocolates(int n) {
        this.stock = n;
    }

    @Override
    public void run() {
        while (true) {
            try {
                // we restock if needed
                if (stock < limit) {
                    System.out.println("Restock from " + stock + " to 1000, warehouse has " + warehouse.getStorage() + " left.");
                    warehouse.setStorage(warehouse.getStorage() - (limit - stock));
                    stock = limit;
                }

                // and then we wait for 5 seconds until the next restock from warehouse
                Thread.sleep(5000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public String toString() {
        return "In stock: " + stock + "\n";
    }
}
